<id>
Manage Notifications
</id>

<version>
.2 beta
</version>

<mod info>
Allows for displaying, editing or deleting New Post E-Mail Notifications.
Adds a link in Admin Center "Manage Notifications".

New since beta .1:
Added support for Notify Plus Thread notifications(may add Board notification support in the future).
Added color highlighting of E-Mail addresses that have matched a search criteria, if a criteria was used.
Moved the location of the "Manage Notifications" link in Admin Center, so that it wasn't between 
the "Rebuild Memberlist" link and text.
Fixed a few other very minor bugs. 

Install the specific version for your YaBB version.
This mod file is for YaBB SP1.1/SP1.2

Selection criteria is as follows: 
1) "Display All Notifications" - This will display a list of all threads and the E-Mail addresses that have at least one Member receiving a Notification. 
2) "Search for Notifications by Thread Number" - This will list the E-Mail addresses of a specific thread by providing a valid "Thread" number. 
3) "Search for Notifications by Member" - All Notifications of a specific Member can be listed, by providing a valid Members username. This must be a "username" and not a "displayname". 
4) "Search for Notifications by E-Mail Address" - Entering a complete or partial E-Mail address of a Member(* and ? wildcards are acceptable), will list all Notifications that are being sent to that E-Mail Address.


Files modified and need to be uploaded:
english.lng
YaBB.pl
Sources/Notify.pl
Sources/Admin.pl

Credits - BHRA - Adapted some of his code into this mod from his "Search Color"(color highlighting of search results) and "Memberview Plus"(pagination).
        - Altan, dOCda S! - Adapted into this mod, the wild card search routine from the "Member Search" mod.

</mod info>

<author>
DummyProof
</author>

<homepage>
http://cgi.tripod.com/yabbsp1_1/cgi-bin/YaBB.pl
</homepage>

<edit file>
english.lng
</edit file>

<search for>
if($MenuType == 1) {
</search for>

<add before>
#####Manage Notifications
$shnot{'1'} = "Manage Notifications";
$shnot{'2'} = "Notifications can be either \"Edited\" or completely \"Deleted\" by choosing the appropriate link.";
$shnot{'2a'} = "Thread starters are marked as \"Guest\" or \"Deleted\"(former Member), where applicable.";
$shnot{'3'} = "Deleted";
$shnot{'4'} = "Edit";
$shnot{'5'} = "Delete";
$shnot{'6'} = "Delete this Notification?";
$shnot{'7'} = "Notification Addresses";
$shnot{'8'} = "Edit Notifications";
$shnot{'9'} = "Delete or add E-Mail Addresses one per line.";
$shnot{'9a'} = "The \"\|\" and possibly a number following it at the end of the E-Mail Address, is used internally by \"Notify Plus\", and should be left as is.";
$shnot{'10'} = "Display All Notifications.";
$shnot{'10a'} = "Display Notifications";
$shnot{'11'} = "Submit";
$shnot{'12'} = "Use the choices below to view the E-Mail Addresses of Members who receive \"New Posting E-Mail Notifications\" for specific threads.<br><br><b>Selection criteria is as follows:</b><p>1) <b>\"Display All Notifications\"</b> - This will display a list of all threads and the E-Mail addresses that have at least one Member receiving a Notification.<p>2) <b>\"Search for Notifications by Thread Number\"</b> - This will list the E-Mail addresses of a specific thread by providing a valid \"Thread\" number.<p>3) <b>\"Search for Notifications by Member\"</b> - All Notifications of a specific Member can be listed, by providing a valid Members username. This must be a \"username\" and not a \"displayname\".<p>4) <b>\"Search for Notifications by E-Mail Address\"</b> - Entering a complete or partial E-Mail address of a Member(* and ? wildcards are acceptable), will list all Notifications that are being sent to that E-Mail Address.";
$shnot{'13'} = "Search for Notifications by Thread Number.";
$shnot{'14'} = "Search for Notifications by Member.";
$shnot{'15'} = "Search for Notifications by E-Mail Address.";
$shnot{'16'} = "<b>Not a Valid Thread Number.</b>";
$shnot{'17'} = "<b>Not a Valid Username.</b><br>Make sure the Members \"Username\" is entered, and not their \"Displayname\".";
$shnot{'18'} = "Viewing All";
$shnot{'19'} = "Search Results";
$shnot{'20'} = "Viewing";
$shnot{'21'} = "Or enter a <b>Search Criteria</b>:";
#####Manage Notifications

</add before>

<edit file>
YaBB.pl
</edit file>

<search for>
	elsif ($action eq 'notify4') { require "$sourcedir/Notify.pl"; &Notify4; }
</search for>

<add after>
	elsif ($action eq 'notifymanage') { require "$sourcedir/Notify.pl"; &ManageNotifications; }
	elsif ($action eq 'notifydelete') { require "$sourcedir/Notify.pl"; &DeleteNotification; }
	elsif ($action eq 'notifyedit') { require "$sourcedir/Notify.pl"; &EditNotifications; }
	elsif ($action eq 'notifyedit2') { require "$sourcedir/Notify.pl"; &EditNotifications2; }
	elsif ($action eq 'notifyshowall') { require "$sourcedir/Notify.pl"; &ShowAllNotifications; }
</add after>

<edit file>
Sources/Notify.pl
</edit file>

<search for>
1;
</search for>

<add before>
sub ManageNotifications {
	&is_admin;
	$yymain .= qq~
<table border=0 cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align="center" cellpadding="4" width="580">
  <tr>
    <td bgcolor="$color{'titlebg'}" class="titlebg">
    <img src="$imagesdir/notify.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$shnot{'1'}</b></font></td>
  </tr><tr>
    <td bgcolor="$color{'windowbg'}" class="windowbg">
    <blockquote><font size="2"><BR>$shnot{'12'}</font></blockquote></td>
  </tr><tr>
    <td bgcolor="$color{'windowbg2'}" class="windowbg2">
    <form action="$scripturl?action=notifyshowall" method="POST">
     <table border=0 align="center">
      <tr><td align="left"><input type="radio" name="notifytype" value="1" checked><font size=2>$shnot{'10'}</font></td></tr>
      <tr><td align="left"><font size=2>&nbsp;&nbsp;&nbsp;&nbsp;$shnot{'21'}</font><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="text" name="notifysearch" value="" size="40"></td></tr>
      <tr><td align="left"><input type="radio" name="notifytype" value="2"><font size=2>$shnot{'13'}</font></td></tr>
      <tr><td align="left"><input type="radio" name="notifytype" value="3"><font size=2>$shnot{'14'}</font></td></tr>
      <tr><td align="left"><input type="radio" name="notifytype" value="4"><font size=2>$shnot{'15'}</font></td></tr>
      <tr><td align="center"><input type=submit value="$shnot{'11'}">&nbsp;&nbsp;<input type=reset value="$txt{'278'}"><br><br>
       <a href="javascript:history.back(-1)"><font size="2">[ $txt{'193'} ]</font></a></td></tr>
       </form>
     </table>
    </td>
  </tr>
</table>
~;
	$yytitle = $shnot{'1'};
	&template;
	exit;
}

sub ShowAllNotifications {

	&is_admin;
	if(-e "$sourcedir/NotifyPlus.pl"){$nplus = 1;}
	my(@dirdata,@datdata,$filename,$entry,@entries,$mnum,$dummy,$msub,$mname,$memail,$mdate,$musername,$micon,$mattach,$mip,$mmessage,@messages,@found_number,@found_subject,@found_date,@found_username);
	if($FORM{'notifysearch'}){$search = $FORM{'notifysearch'};}
	elsif($INFO{'notifysearch'}){$search = $INFO{'notifysearch'};}
	else {$searchtype = 1; $search = 'all';}
	chomp $search;
	if($FORM{'notifytype'} == 2 || $INFO{'notifytype'} == 2){ $searchtype = 2;}
	elsif($FORM{'notifytype'} == 3 || $INFO{'notifytype'} == 3){ $searchtype = 3;}
	elsif($FORM{'notifytype'} == 4 || $INFO{'notifytype'} == 4){ $searchtype = 4;}
	else {$searchtype = 1; $search = 'all';}
	$search2 = $search;

	if ($search eq "" || $search eq "*") { $search = "\\w";} 
	if($search =~ /\*/) {
		$search =~ s/\*+/\*/g;
		if($search =~ /\*$/) {$search=substr($search,0,length($search)-1); $look = "\^$search";}
		elsif($search =~ /^\*/) {$search=substr($search,1); $look = "$search\$";}
		else { ($f,$l) = split(/\*/,$search); $look = "\^($f).*($l)\$"; }
	} else {$look = $search;}

	# Read all .mail-Files and search for username
	$found = '';
if($searchtype == 2){ 
	if(-e "$datadir/$search.mail"){
		$found = 1;
		$datdata[0] = "$search.mail";
	} else {
		$errortext = qq~$shnot{'16'}~;
	}
}
elsif($searchtype == 3){
	if(-e "$memberdir/$search.dat"){
		fopen(FILE,"$memberdir/$search.dat");
		@member = <FILE>;
		fclose(FILE);
		$look = $member[2];
		chomp $look;
		opendir (DIRECTORY,"$datadir");
		@dirdata = readdir(DIRECTORY);
		closedir (DIRECTORY);
		@datdata = grep(/mail/,@dirdata);
	} else {
		$errortext = qq~$shnot{'17'}~;
	}
} else {
	opendir (DIRECTORY,"$datadir");
	@dirdata = readdir(DIRECTORY);
	closedir (DIRECTORY);
	@datdata = grep(/mail/,@dirdata);
}
	# Load Censor List
	&LoadCensorList;
	
	foreach $filename (@datdata) {
		fopen(FILE, "$datadir/$filename");
		@entries = <FILE>;
		fclose(FILE);
		if($searchtype >= 3){
			$found = '';
		        foreach $entry (@entries) {
				if($nplus){($entry, $dummy) = split(/\|/,$entry);}
				chomp $entry;
				if($entry =~ /$look/ig){ $look2 = $entry; $found = 1; last;}
			}
		}
		if(!$found && $searchtype != 1){next;}
		($mnum, $dummy) = split(/\./,$filename);
		fopen(FILE, "$datadir/$mnum.txt");
		@messages = <FILE>;
		fclose(FILE);
		($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip,  $mmessage) = split(/\|/,$messages[0]);
		push(@found_number,$mnum);
		push(@found_subject,$msub);
		push(@found_date,$mdate);
		push(@found_username,$musername);
		push(@found_name,$mname);
		$emaillist = '';
	        foreach $entry (@entries) {
			if(!$searchcolor{'colorh'}){$searchcolor{'colorh'} = "#ff0000";} # Searchcolor of E-Mail addy
			if(!$searchcolor{'highlighth'}){$searchcolor{'highlighth'} = "#ffff00";} # Highlightcolor of E-Mail addy
			if($nplus){($entry, $dummy) = split(/\|/,$entry);}
			chomp $entry;
			if(($searchtype >= 3) && ($entry =~ /$look/ig)) {$entry =~ s~$entry~<font size="1" color="$searchcolor{'colorh'}" class="highlight" style="background-color:$searchcolor{'highlighth'};"><b>$entry</b></font>~ig;}
			elsif ($entry =~ /$look/ig) {$entry =~ s~(^|\W|_)(\Q$look2\E)(?=$|\W|_)~$1<font size="1" color="$searchcolor{'colorh'}" class="highlight" style="background-color:$searchcolor{'highlighth'};"><b>$2</b></font>$3~ig;}
			$emaillist .= qq~ &lt;&nbsp;$entry&nbsp;&gt;&nbsp;~;
		}
		$allmails{$mnum} = $emaillist;
		$total{$mnum} = ($#entries + 1);
	}

	# Construct the page links for this board.
	$notifycount = $#found_number + 1;
	$NotifysPerPage = $maxmessagedisplay;	# max number of Notifications per page
	if($INFO{'start'} eq "all") { $start = 0; $showall = 1; } 
	elsif($INFO{'start'}) { $start = $INFO{'start'}; }
	else { $start = 0; }
	$numbegin = ($start + 1);
	$numend = ($start + $NotifysPerPage);
	if($numend > $notifycount) { $numend = $notifycount; }
	$b = $start;

	$indexdisplaynum = 4;	# max number of pages to display
	$startpage = 0;
	$tmpa = 1;
	$tmpx = int( $notifycount / $NotifysPerPage);
	if ($start >= (($indexdisplaynum-1) * $NotifysPerPage)) {
		$startpage = $start - (($indexdisplaynum-1) * $NotifysPerPage);
		$tmpa = int( $startpage / $NotifysPerPage) + 1;
	}
	if ( $notifycount >= $start + ($indexdisplaynum * $NotifysPerPage)) {$endpage = $start + ($indexdisplaynum * $NotifysPerPage); } else { $endpage = $notifycount }
	if ($startpage > 0) { $pageindex = qq~<a href="$scripturl?action=notifyshowall;start=0;notifysearch=$search2;notifytype=$searchtype">1</a>&nbsp;...&nbsp;~; $tstart= qq~;start=0~;}
	if ($startpage == $NotifysPerPage) { $pageindex = qq~<a href="$scripturl?action=notifyshowall;start=0;notifysearch=$search2;notifytype=$searchtype">1</a>&nbsp;~; $tstart= qq~;start=0~;}
	for( $counter = $startpage; $counter < $endpage; $counter += $NotifysPerPage) {
		if($start == $counter && !$showall) {
			$pageindex .=qq~<B>$tmpa</B>&nbsp;~;
			$tstart = qq~;start=$counter~;
		} else { 
			$pageindex .= qq~<a href="$scripturl?action=notifyshowall;start=$counter;notifysearch=$search2;notifytype=$searchtype">$tmpa</a>&nbsp;~;
		}
		++$tmpa;
	}
	$tmpx = $notifycount - 1 - $NotifysPerPage;
	$outerpn = int($tmpx / $NotifysPerPage);
	$lastpn = int(($notifycount - 1) / $NotifysPerPage) + 1;
	$lastptn = ($lastpn - 1) * $NotifysPerPage;
	if ($endpage < $notifycount - $NotifysPerPage) {$pageindexadd = qq~...&nbsp;~;}
	if ($endpage != $notifycount) {$pageindexadd .= qq~<a href="$scripturl?action=notifyshowall;start=$lastptn;notifysearch=$search2;notifytype=$searchtype">$lastpn</a>&nbsp;~;}
	$pageindex .= $pageindexadd;
	if ($showall) {$pageindex .= qq~$txt{'190'}~; $NotifysPerPage = $notifycount; $tstart= qq~;start=all~; $header = qq~$shnot{'18'} $notifycount $shnot{'19'}~; }
	else {$pageindex .= qq~<a href="$scripturl?action=notifyshowall;start=all;notifysearch=$search2;notifytype=$searchtype">$txt{'190'}</a>~; $header = qq~$shnot{'20'} $shnot{'19'} $numbegin $txt{'311'} $numend ($txt{'309'} $notifycount $txt{'94'} $shnot{'19'})~;}
	if($NotifysPerPage > $notifycount){$pageindex = '';}

	# Display all Entries
	$yymain .= qq~
<table border=0 width="90%" align="center" cellspacing=1 cellpadding=6 bgcolor="$color{'bordercolor'}" class="bordercolor">
 <tr>
  <td bgcolor="$color{'titlebg'}" class="titlebg"><img src="$imagesdir/notify.gif" alt="" border="0">
   <font size=2 color="$color{'titletext'}" class="text1"> <b>$shnot{'10a'}</b></font>
  </td>
 </tr><tr>
  <td align="center" bgcolor="$color{'windowbg'}" class="windowbg">
   <font size=2>
    <br>
~;
	if (@found_number==0) {
		if(!$errortext){$errortext = qq~$txt{'414'}~;}
		$yymain .= qq~$errortext<br><br>
		<a href="javascript:history.back(-1)"><font size="2">[ $txt{'193'} ]</font></a>~;
	} else {
		foreach (@censored) {
		($tmpa,$tmpb) = @{$_};
		$found_subject[$counter] =~ s~\Q$tmpa\E~$tmpb~gi;
		}
		$yymain .= qq~
<table border=0 width="90%">
  <tr>
    <td colspan=3><font size=2>$shnot{'2'}<br>
    $shnot{'2a'}</font><br><br><font size=2><b>$header</b></font><br>
    </td>
  </tr>
~;
		my $dname = '';
		$counter = $b;
		$stop = $notifycount - $counter;
		while($numshown < $NotifysPerPage) {
			if($stop == $numshown){ last;}
			$numshown++;
			if(-e "$memberdir/$found_username[$counter].dat" && $found_username[$counter] ne 'Guest'){
				&LoadUser($found_username[$counter]);
				$dname = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$found_username[$counter]}">$userprofile{$found_username[$counter]}->[1]</a>~;
			} else {
				$dname = qq~$found_name[$counter]~;
				if($found_username[$counter] eq 'Guest'){
					$dname .= qq~ <font size=1>($txt{'28'})</font>~;
				} else {
					$dname .= qq~ <font size=1>($shnot{'3'})</font>~;
				}
			}
			$yymain .= qq~
			<tr>
			 <td colspan=3>
			  <table border=0 width="100%" cellspacing=1 cellpadding=6 bgcolor="$color{'bordercolor'}" class="bordercolor">
			   <tr>
			    <td bgcolor="$color{'windowbg2'}" class="windowbg2" colspan=2>
			     <font size=2><b>$found_subject[$counter]</b> $txt{'525'} $dname</font>
			    </td>
			    <td width="12%" align="center" bgcolor="$color{'catbg'}" class="catbg"><a href="$scripturl?action=notifyedit;thread=$found_number[$counter];notifysearch=$search2;notifytype=$searchtype$tstart">[ $shnot{'4'} ]</a>
			    </td>
			    <td width="12%" align="center" bgcolor="$color{'catbg'}" class="catbg"><a href="$scripturl?action=notifydelete;thread=$found_number[$counter];notifysearch=$search2;notifytype=$searchtype$tstart" onclick="return confirm('$shnot{'6'}')">[ $shnot{'5'} ]</a>
			    </td>
			   </tr>
			   <tr>
			    <td width="5%" align="center" valign="top" bgcolor="$color{'windowbg2'}" class="windowbg2"><b>$txt{'94'}:<br>$total{$found_number[$counter]}</b>
			    </td>
			    <td colspan=3 valign="top" bgcolor="$color{'windowbg2'}" class="windowbg2">
			     <font size=1><b><i>$shnot{'7'}:</i></b></font><font size=1>&nbsp;&nbsp;&nbsp;$allmails{$found_number[$counter]}</font>
			    </td>
			   </tr>
			  </table>
			 </td>
			</tr>
			~;
			$counter++;
		}
		$yymain .= qq~
			<tr><td valign="top" width="35%" align="left" ><font size=2>$pageindex</font></td>
			<td width="30%" align="center" ><a href="$scripturl?action=notifymanage"><font size="2">[ $shnot{'1'} ]</font></a>
			<br><a href="javascript:history.back(-1)"><font size="2">[ $txt{'193'} ]</font></a>
			</td><td width="35%">&nbsp;</td></tr>
			</table>~;
	}
	$yymain .= qq~
   </font>
  </td>
 </tr>
</table>
~;
	$yytitle = "$shnot{'10a'}";
	&template;
	exit;
}

sub EditNotifications {
	&is_admin;
	if(-e "$sourcedir/NotifyPlus.pl"){$nplus = 1;}
	my ($threadno) = $INFO{'thread'};
	fopen(FILE, "$datadir/$threadno.mail");
	@addresses = <FILE>;
	fclose(FILE);

	$yymain .= qq~
<table border=0 cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align="center" cellpadding="4" width="580">
  <tr>
    <td bgcolor="$color{'titlebg'}" class="titlebg">
    <img src="$imagesdir/notify.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"> <b>$shnot{'8'}</b></font></td>
  </tr><tr>
    <td bgcolor="$color{'windowbg'}" class="windowbg">
    <blockquote><font size="2"><BR>$shnot{'9'}</font></blockquote>
~;
if($nplus){
	$yymain .= qq~
    <blockquote><font size="2">$shnot{'9a'}</font></blockquote><BR>
~;
}
	$yymain .= qq~
   </td>
  </tr><tr>
    <td bgcolor="$color{'windowbg2'}" class="windowbg2"><br>
    <form action="$scripturl?action=notifyedit2" method="POST">
    <center>
    <input type="hidden" value="$INFO{'notifysearch'}" name="notifysearch">
    <input type="hidden" value="$INFO{'notifytype'}" name="notifytype">
    <input type="hidden" value="$INFO{'start'}" name="start">
    <input type="hidden" value="$threadno" name="threadno">
    <textarea cols=60 rows=8 name="addys" wrap="off">
~;
	foreach $i (@addresses) {
		chomp $i;
		$yymain .= "$i\n";
	}
	$yymain .= qq~</textarea><br><br>
    <input type=submit value="$txt{'10'}"><br><br>
    <a href="javascript:history.back(-1)"><font size="2">[ $txt{'193'} ]</font></a>
    </center></form>
    </td>
  </tr>
</table>
~;
	$yytitle = $shnot{'8'};
	&template;
	exit;
}

sub EditNotifications2 {
	&is_admin;
	if(-e "$sourcedir/NotifyPlus.pl"){$nplus = 1;}
	my (@mails, $thread, $curmail);
	if($FORM{'notifysearch'}){$ns = qq~;notifysearch=$FORM{'notifysearch'}~;}
	if($FORM{'notifytype'}){$nt = qq~;notifytype=$FORM{'notifytype'}~;}
	if($FORM{'start'}){$sn = qq~;start=$FORM{'start'}~;}
	$FORM{'addys'} =~ tr/\r//d;
	$FORM{'addys'} =~ s~\A\n~~;
	$FORM{'addys'} =~ s~\n\Z~~;
	my @mails = split( /\n/, $FORM{'addys'} );
	foreach $echeck (@mails){
		if($nplus == 1){($echeck, $dummy) = split(/\|/,$echeck);}
		&fatal_error("$txt{'240'} $txt{'69'} $echeck") if($echeck !~ /[\w\-\.\+]+\@[\w\-\.\+]+\.(\w{2,4}$)/);
		&fatal_error("$txt{'500'}") if(($echeck =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/) || ($echeck !~ /\A.+@\[?(\w|[-.])+\.[a-zA-Z]{2,4}|[0-9]{1,4}\]?\Z/));
	}
	$thread = $FORM{'threadno'};
	if(@mails){ 
		fopen(FILE, ">$datadir/$thread.mail", 1) || &fatal_error("$txt{'23'} $thread.mail");
		print FILE $FORM{'addys'};
		print FILE "\n";
		fclose(FILE);
	}

	$yySetLocation = qq~$scripturl?action=notifyshowall$ns$nt$sn~;
	&redirectexit;
}

sub DeleteNotification {
	&is_admin;
	my ($threadno) = $INFO{'thread'};
	if($INFO{'notifysearch'}){$ns = qq~;notifysearch=$INFO{'notifysearch'}~;}
	if($INFO{'notifytype'}){$nt = qq~;notifytype=$INFO{'notifytype'}~;}
	if($INFO{'start'}){$sn = qq~;start=$INFO{'start'}~;}
	unlink("$datadir/$threadno.mail");

	$yySetLocation = qq~$scripturl?action=notifyshowall$ns$nt$sn~;
	&redirectexit;
}

</add before>

<edit file>
Sources/Admin.pl
</edit file>

<search for>
        - <a href="$cgi;action=membershiprecount">$txt{'504'}</a><br>
</search for>

<add before>
        - <a href="$scripturl?action=notifymanage">$shnot{'1'}</a><BR>
</add before>